var api = api || {};
(function() {
    api.init = function(token, userid, endpoint) {
        console.log('initializing');
        if(!tc.util.isEmpty(endpoint)){
            tc.conf.env = "http://" + endpoint;
            tc.conf.appUrl = "http://" + endpoint + "/webjim-echat/clientApi/html/mobile.html";
        }
        tc.app.initialize({
            "token": token,
            "userId": userid
        });
    }
    api.embedroomlist = function(divele) {
        tc.app.embedRooms(divele);
    }
    api.embedroom = function(divele, room) {
        tc.app.embedRoom(divele, room);
    }
    api.embedmessage = function(divele, roomid, messageid) {
        tc.app.embedChatlet(divele, roomid, messageid)
    }
    api.createroom = function(groupname, membersemail, welcomemsg) {
        var url = "/api/rooms/";
        var method = "POST";
        var data = {
            welcomemessage: welcomemsg,
            emails: membersemail,
            name: groupname
        };
        api.ApiCall(url, data, method);
    }
    api.addmembers = function(roomid, memberemails) {
        var url = "/api/rooms/" + roomid + "/members";
        var method = "POST";
        var data = {
            emails: memberemails
        };
        api.ApiCall(url, data, method);
    }
    api.sendmessage = function(roomid, msg) {
        var url = "/api/rooms/" + roomid + "/messages";
        var method = "POST";
        var data = {
            text: msg
        };
        api.ApiCall(url, data, method);
    }
    api.rename = function(roomid, name) {
        var url = "/api/rooms/" + roomid + "/update";
        var method = "POST";
        var data = {
            newName: name
        };
        api.ApiCall(url, data, method);
    }
    api.removeMember = function(roomid, memberid) {
        var url = "/api/rooms/" + roomid + "/members/" + memberid;
        var method = "DELETE";
        var data = {
            member: memberid
        };
        api.ApiCall(url, data, method);
    }
    api.ApiCall = function(inputurl, parameters, method) {
        $.ajax({
            url: tc.conf.env + inputurl,
            data: parameters,
            type: method,
            headers: {
                "authorization": "Gupshup " + tc.conf.userId + ":" + tc.conf.token + ":echat",
                "Accept": "application/vnd.gupshup.privatechat-v1+json"
            },
            dataType: "json",
            success: function(json) {
                console.log(json);
            },
            error: function(xhr, status, errorThrown) {
                console.log("Error: " + errorThrown);
                console.log("Status: " + status);
                console.dir(xhr);
            },
            complete: function(xhr, status) {
                console.log("done");
            }
        });
    }
})();

var tc = tc || {};
(function() {
    tc.conf = {
        appUrl : 'http://enterprise.teamchat.com/webjim-echat/clientApi/html/mobile.html',
        env : 'https://enterprise.teamchat.com',
        siteUrl : window.location.origin
    },
    tc.app = {
        initialize : function (data){
            try{
                for (i in data){
                    tc.conf[i] = data[i];//Creating a deep copy
                }
                var keys = ['userId','token','googleId','fbId'];
                tc.conf.missingKeys = [];
                for(i in keys){
                    if(tc.util.isEmpty(data[keys[i]]))
                        tc.conf.missingKeys.push(keys[i]);
                }
                if(tc.conf.missingKeys.length)
                    throw new Error("Missing keys : "+tc.conf.missingKeys.join(','));
                tc.util.log('initialization complete \n'+Object.keys(data));
            }catch(err){
                tc.util.log(err.message,"error");
            }
        },
        registerNotificationHandler : function (handler){
            tc.util.log('registering',handler);
        },
        verify : function(){
            //return (tc.conf.missingKeys.length); Giving a pass for token less users;
            return false;
        },
        askFriend : function(div,msg,callback){
            if(!this.verify()){
                //{text :'NeelKamal MattreZzz', displayname:'Pepperfry : NeelKamal Mattress', url:tc.conf.imgUrl, productUrl:window.location.href}
                tc.util.log(div,msg,callback);
                var iframe = tc.html.createIframe(msg);
                tc.util.createInterface(div,iframe);
                tc.events.init(div,"askFriend",callback);
            }else{tc.util.log("Missing Keys : "+tc.conf.missingKeys.join(','))}
        },
        embedRooms : function(div,callback){
            if(!this.verify()){
                var iframe = tc.html.getDeepLinkedUrl('rooms');
                var percent = 0.75;
                iframe.style.width=100.0/percent+"%";
                iframe.style.height=100.0/percent+"%";
                iframe.style.zoom=percent;
                iframe.style.webkitTransform='scale('+percent+')';
                iframe.style.webkitTransformOrigin='top left';
                iframe.style.MozTransform='scale('+percent+')';
                iframe.style.MozTransformOrigin='top left';
                iframe.style.oTransform='scale('+percent+')';
                iframe.style.oTransformOrigin='top left';
                tc.util.createInterface(div,iframe);
                tc.events.init(div,"embedRooms",callback);
            }else{tc.util.log("Missing Keys : "+tc.conf.missingKeys.join(','))}
        },
        embedRoom : function(div,roomId,callback){
            if(!this.verify()){
                tc.util.log(div,roomId);
                var iframe = tc.html.getDeepLinkedUrl('stream',{'roomId':roomId});
                tc.util.createInterface(div,iframe);
                tc.events.init(div,"embedRoom",callback);
            }else{tc.util.log("Missing Keys : "+tc.conf.missingKeys.join(','))}
        },
        embedChatlet : function(div,roomId,formId,callback){
            if(!this.verify()){
                tc.util.log(div,roomId,formId);
                var iframe = tc.html.getDeepLinkedUrl('msg',{'roomId':roomId,'mId':formId});
                tc.util.createInterface(div,iframe);
                tc.events.init(div,"embedChatlet",callback);
            }else{tc.util.log("Missing Keys : "+tc.conf.missingKeys.join(','))}
        }
     },
     tc.html = {
        createIframe : function(item){
            var group = "&gId="+tc.util.getUrlParam('gId'); //"55a76f076fc406d475423b11";
            var messageId = "&mId="+tc.util.getUrlParam('mId'); //"55a76f076fc406d475423b11";
            var data = this.productDetails(item);
            var domain = "&domain="+tc.conf.siteUrl;
            var url = tc.conf.appUrl+'?data='+data+domain+group+messageId+'&v='+new Date().getTime();
            var iframe = document.createElement('iframe');
            iframe.setAttribute("src",url);
            return iframe;
        },
        getDeepLinkedUrl : function(elem,params){
            var iframe ="";
            switch (elem){
                case 'msg' :
                    iframe = this.createChatletIframe(params);
                    break;
                case 'stream' : 
                    iframe = this.createStreamIframe(params);
                    break;
                case 'rooms' :
                default:
                    iframe = this.createRoomsIframe();
                    break;
            }
            return iframe;
        },
        createRoomsIframe : function(){
            tc.util.log('rooms');
            var url = tc.conf.appUrl+'?default=true&domain='+tc.conf.siteUrl+'&tk='+tc.conf.token+'&uId='+tc.conf.userId;
            tc.util.log(url);
            var iframe = document.createElement('iframe');
            iframe.setAttribute("src",url);
            iframe.setAttribute("height","100%");
            iframe.setAttribute("width","100%");
            tc.util.log(iframe);    
            return iframe;
        },
        createChatletIframe : function(params){
            var url = tc.conf.env+'/webjim-echat/clientApi/html/cmsg.html?gId='+params.roomId+'&domain='+tc.conf.siteUrl+'&mId='+params.mId+'&tk='+tc.conf.token+'&uId='+tc.conf.userId;
            var iframe = document.createElement('iframe');
            iframe.setAttribute("src",url); 
            iframe.setAttribute("height","100%");
            iframe.setAttribute("width","100%");
            return iframe;
        },
        createStreamIframe : function(params){
            var url = tc.conf.env+'/webjim-echat/clientApi/html/stream.html?gId='+params.roomId+'&tk='+tc.conf.token+'&uId='+tc.conf.userId+'&domain='+tc.conf.siteUrl;
            var iframe = document.createElement('iframe');
            iframe.setAttribute("src",url); 
            iframe.setAttribute("height","100%");
            iframe.setAttribute("width","100%");
            return iframe;
        },
        msgJson : function(item){
            return JSON.stringify({"productURL":item.productUrl,"content":{"text":item.text,"html":"<img style='width:100%;height:300px;' src = '"+item.url+"'/>"},"imgUrl":"","xslt":"primary-2.7.2","summdesc":{"fields":[{"operation":"Count","drilldown":"resp","hidden":"true","name":"yesno","display":"Count","fieldname":"resp"}]},"detailsLinkVisibility":"all","queslabel":"Question","detdesc":{"label":"Replies","showcount":"true","fields":[{"display":"Response","key":"resp"}]},"type":"primary","actionreplace":"replace","actions":{"actitem":[{"yesno":{}}]},"displayname":item.displayname,"minCrv":"3","comments":{"addcomment":"true"}});
        },
        productDetails : function(item){
            var sid = tc.conf.token;
            if(sid != null)
                return btoa(JSON.stringify({"sid":sid,"message":btoa(this.msgJson(item))}));
            else
                return btoa(JSON.stringify({"message":btoa(this.msgJson(item))}));;
        }
     }
     tc.events ={
        init : function(widget,msg,callback){
            setTimeout(function(){tc.events.send(widget,msg,callback);return;}, 2000);
            this.receive(callback);
        },
        send : function(widget,msg,callback){
            tc.util.log(widget);
            try{
            var frame = widget.getElementsByTagName('iframe')[0];
                frame.contentWindow.postMessage({"message":msg,"data":tc.conf}, '*');
            }catch(err){tc.util.log(err,"error");}
        },
        receive : function(callback){
            var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
            var eventer = window[eventMethod];
            var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";
            try{
                eventer(messageEvent,function(e) {
                    tc.util.log('reading from inside',e);
                    if(e.data)
                        callback(e);//Registering custom callback function.
                },false);
            }catch(err){
                tc.util.log('Error :'+err);
            }
        }
    },
     tc.util = {
        deepFind : function(obj, path) {
            var paths = path.split('.')
            , current = obj
            , i;

            for (i = 0; i < paths.length; ++i) {
                if (current[paths[i]] == undefined) {
                    return undefined;
                } else {
                    current = current[paths[i]];
                }
            }
            return current;
        },
        createInterface : function(div,iframe){
            if(div){
                var div = document.getElementById(div);
                div.innerHTML = "";
                div.appendChild(iframe);
            }else{
                var st="toolbar=0,location=1,directories=0,status=1,menubar=0,scrollbars=1,resizable=0,top=0,left=0,width=460,height="+(screen.height*.8)+";";
                mainwin=window.open(iframe.src,"Powered by Teamchat",st);
                tc.util.log(mainwin);
                mainwin.onbeforeunload = function(){
                    tc.util.log('before unload',"warning");
                };   
                mainwin.addEventListener('beforeunload',function(e){
                    tc.util.log('fired close event',"warning");
                },false);
            }
        },
        getParam : function(path){
            return this.deepFind(tc,path) ;
        },
        getUrlParam : function(name) {
            return decodeURI(
                (RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]
            );
        },
        log: function(data,type) {
            try
            {
                if(typeof logstr == "object")
                    logstr = JSON.stringify(data)
                var type=(type)?type:"log";
                if (window.console) {
                    window.console.log(data);
                }
            }
            catch(e)
            {
            }
        },
        isEmpty : function (obj){
            if(typeof obj == "undefined" || obj == "" || obj == null || obj == "null")
                return true;
            else if(typeof obj == "object" && Object.keys(obj).length == 0)
                return true;
            else if(typeof obj == "string" && obj.trim().length == 0)
                return true;
            return false;
        }
     }
})();